Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDepthMapGenerator.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComDepthMapGenerator.cpp	(revision 193)
@@ -743,5 +743,5 @@
       {
 #if VSP_N
-        if( pcSlice->getRefViewId( eRefPicList, iPdmRefIdx ) != NUM_VIEW_VSP )
+        if( !pcCU->isVspRef( eRefPicList, iPdmRefIdx ) )
 #endif
         if( pcSlice->getRefPOC( eRefPicList, iPdmRefIdx ) == pcSlice->getPOC())
@@ -846,5 +846,5 @@
   Bool          bInterview  = ( uiRefViewId < m_uiCurrViewId );
 #if VSP_N
-  Bool          bVsp        = ( pcRefPic->getViewId() == NUM_VIEW_VSP );
+  Bool          bVsp        = pcCU->isVspRef( eRefPicList, iRefIdx );
   AOT(  bInterview &&  bVsp && iRefPoc != pcSlice->getPOC() );
   AOT( !bInterview && !bVsp && iRefPoc == pcSlice->getPOC() );
@@ -947,5 +947,5 @@
   Bool          bInterview  = ( uiRefViewId < m_uiCurrViewId );
 #if VSP_N
-  Bool          bVsp        = ( pcRefPic->getViewId() == NUM_VIEW_VSP );
+  Bool          bVsp        = pcCU->isVspRef( eRefPicList, iRefIdx );
   AOT(  bInterview &&  bVsp && iRefPoc != pcSlice->getPOC() );
   AOT( !bInterview && !bVsp && iRefPoc == pcSlice->getPOC() );
@@ -1502,6 +1502,6 @@
     Bool            bUsesInterViewPrd = ( abCurrIntView[0] || abCurrIntView[1] );
 #if VSP_N
-    if(( aiCurrRefIdx[0] >= 0 && pcCU->getSlice()->getRefPic( REF_PIC_LIST_0, aiCurrRefIdx[0] )->getViewId() == NUM_VIEW_VSP ) ||
-       ( aiCurrRefIdx[1] >= 0 && pcCU->getSlice()->getRefPic( REF_PIC_LIST_1, aiCurrRefIdx[1] )->getViewId() == NUM_VIEW_VSP )) {
+    if(( aiCurrRefIdx[0] >= 0 && pcCU->isVspRef( REF_PIC_LIST_0, aiCurrRefIdx[0] ) ) ||
+       ( aiCurrRefIdx[1] >= 0 && pcCU->isVspRef( REF_PIC_LIST_1, aiCurrRefIdx[1] ) )) {
       //if refpic is VSP, copy to Original cuurent PDM
       TComPicYuv* pcPdm = pcCU->getPic()->getPredDepthMap();
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPic.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPic.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPic.cpp	(revision 193)
@@ -69,7 +69,4 @@
   m_pcResidual        = NULL;
 #endif
-#if DEBUGIMGOUT
-  m_acPicYuvDebug     = NULL;
-#endif
   m_pcPicYuvPred      = NULL;
   m_pcPicYuvResi      = NULL;
@@ -102,8 +99,5 @@
   }
   m_apcPicYuv[1]  = new TComPicYuv;  m_apcPicYuv[1]->create( iWidth, iHeight, uiMaxWidth, uiMaxHeight, uiMaxDepth );
-#if DEBUGIMGOUT
-  m_acPicYuvDebug    = new TComPicYuv;  m_acPicYuvDebug->create( iWidth, iHeight, uiMaxWidth, uiMaxHeight, uiMaxDepth );
-#endif
-
+  
   /* there are no SEI messages associated with this picture initially */
   m_SEIs = NULL;
@@ -172,12 +166,4 @@
     delete m_pcResidual;
     m_pcResidual = NULL;
-  }
-#endif
-#if DEBUGIMGOUT
-  if (m_acPicYuvDebug)
-  {
-    m_acPicYuvDebug->destroy();
-    delete m_acPicYuvDebug;
-    m_acPicYuvDebug = NULL;
   }
 #endif
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPic.h
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPic.h	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPic.h	(revision 193)
@@ -91,7 +91,4 @@
   TComPicYuv*           m_pcResidual;             //  residual buffer (coded or inter-view predicted residual)
 #endif
-#if DEBUGIMGOUT
-  TComPicYuv*           m_acPicYuvDebug;          //  debug image
-#endif
 
   TComPicYuv*           m_pcPicYuvPred;           //  Prediction
@@ -120,4 +117,9 @@
   Int**                 m_aaiCodedScale;
   Int**                 m_aaiCodedOffset;
+
+#if OL_DEPTHLIMIT_A0044
+  UInt*                 m_texPartInfo;
+  UInt                  m_uiTexPartIndex;
+#endif
 
 public:
@@ -183,8 +185,4 @@
 #if HHI_INTER_VIEW_RESIDUAL_PRED
   TComPicYuv*   getResidual()         { return  m_pcResidual; }
-#endif
-
-#if DEBUGIMGOUT
-  TComPicYuv*   getPicYuvRecDbg()     { return  m_acPicYuvDebug; }
 #endif
 
@@ -262,4 +260,13 @@
   Void          removeResidualBuffer    ();
 #endif
+
+#if OL_DEPTHLIMIT_A0044
+  UInt        accessPartInfo        ( UInt count )   { return m_texPartInfo[m_uiTexPartIndex + count]; };
+  Void        incrementTexPartIndex (            )   { m_uiTexPartIndex += 2;    };
+  UInt        getTexPartIndex       ()               { return m_uiTexPartIndex;  };
+  Void        setTexPartIndex       ( UInt idx   )   { m_uiTexPartIndex = idx; };
+  Void        setPartInfo           ( UInt* texPart) { m_texPartInfo    = texPart;  };
+#endif
+
   Bool          getValidSlice                                  (Int sliceID)  {return m_pbValidSlice[sliceID];}
   Int           getSliceGranularityForNDBFilter                ()             {return m_sliceGranularityForNDBFilter;}
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPicSym.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPicSym.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPicSym.cpp	(revision 193)
@@ -126,4 +126,15 @@
   m_apcTComDataCU = NULL;
 
+
+#if FIX_MEM_LEAKS
+  if( m_apcTComTile )
+  {
+    for( i=0; i<(m_iNumColumnsMinus1+1)*(m_iNumRowsMinus1+1); i++ )
+    {
+      if ( m_apcTComTile[i] )  delete m_apcTComTile[i];
+    }
+  }
+#endif
+
   delete [] m_apcTComTile;
   m_apcTComTile = NULL;
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPicYuv.h
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPicYuv.h	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComPicYuv.h	(revision 193)
@@ -184,13 +184,4 @@
   Void  setChromaTo  ( Pel pVal );  
 
-#if DEBUGIMGOUT
-  // Degub tools
-public:
-  Void colsetToPicYuv   ( const UChar ucColor[3],                 Int iOffset[2][2], TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
-  Void colsetToPicLuma  ( const UChar ucLumaOffCol,               Int iOffset[2][2], TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
-  Void colsetToPicChroma( const UChar ucUCol, const UChar ucVCol, Int iOffset[2][2], TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
-  Void drawLineToPicYuv ( bool bHor, bool bVer, UInt uiSize,      TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
-#endif
-
 };// END CLASS DEFINITION TComPicYuv
 
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComRdCost.h
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComRdCost.h	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComRdCost.h	(revision 193)
@@ -377,4 +377,10 @@
   Bool                    m_bUseEstimatedVSD; 
 #endif
+#if LGE_WVSO_A0119
+  Int                     m_iDWeight;
+  Int                     m_iVSOWeight;
+  Int                     m_iVSDWeight;
+  Bool                    m_bUseWVSO;
+#endif
 
   Bool                    m_bUseVSO;
@@ -410,5 +416,14 @@
   Void    setVSOMode( UInt uiIn);
   UInt    getVSOMode( )                  { return m_uiVSOMode; }
-
+#if LGE_WVSO_A0119
+  Void    setUseWVSO ( Bool bIn )         { m_bUseWVSO = bIn; }; 
+  Bool    getUseWVSO ( )                  { return m_bUseWVSO;};
+  Void    setDWeight   ( Int iDWeight   ) { m_iDWeight = iDWeight; };
+  Int     getDWeight   ()                 { return m_iDWeight; };
+  Void    setVSOWeight ( Int iVSOWeight ) { m_iVSOWeight = iVSOWeight; };
+  Int     getVSOWeight ()                 { return m_iVSOWeight; };
+  Void    setVSDWeight ( Int iVSDWeight ) { m_iVSDWeight = iVSDWeight; };
+  Int     getVSDWeight ()                 { return m_iVSDWeight; };
+#endif 
 #if HHI_VSO_DIST_INT
   Void    setAllowNegDist ( Bool bAllowNegDist );
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComSlice.cpp	(revision 193)
@@ -112,4 +112,7 @@
 , m_iViewOrderIdx                 ( 0 )
 #endif
+#if VSP_CFG
+, m_uiNumVspRefPics               ( 0 )
+#endif
 {
   m_aiNumRefIdx[0] = m_aiNumRefIdx[1] = m_aiNumRefIdx[2] = 0;
@@ -146,4 +149,10 @@
 #if VSP_SLICE_HEADER
   m_bVspFlag = false;
+#if VSP_CFG
+  memset( m_uiVspRefPos[0], 0, sizeof(UInt)*MAX_NUM_REF_PICS );
+  memset( m_uiVspRefPos[1], 0, sizeof(UInt)*MAX_NUM_REF_PICS );
+#else
+  m_bVspDepthDisableFlag = false;
+#endif
 #endif
 }
@@ -195,4 +204,11 @@
 #if VSP_SLICE_HEADER
   m_bVspFlag = false;
+#if VSP_CFG
+  m_uiNumVspRefPics = 0;
+  memset( m_uiVspRefPos[0], 0, sizeof(UInt)*MAX_NUM_REF_PICS );
+  memset( m_uiVspRefPos[1], 0, sizeof(UInt)*MAX_NUM_REF_PICS );
+#else
+  m_bVspDepthDisableFlag = false;
+#endif
 #endif
 
@@ -544,8 +560,19 @@
   }
 
+#if VSP_CFG
+  UInt cIdxTmp;
+  for( cIdx = 0, cIdxTmp = 0; cIdx <= num_ref_idx_l0_active_minus1; cIdx ++ )
+#else
   for( cIdx = 0; cIdx <= num_ref_idx_l0_active_minus1; cIdx ++ )
+#endif
   {
 #if VSP_N
+#if VSP_CFG
+    Int iVspRefPos = getVspRefPos(REF_PIC_LIST_0, 0);
+    iVspRefPos = ( iVspRefPos > 0 ? iVspRefPos - 1 : -1 );
+    if( pcVspPic && iVspRefPos != -1 && cIdx == (iVspRefPos >= num_ref_idx_l0_active_minus1 ? num_ref_idx_l0_active_minus1 : iVspRefPos) )
+#else
     if( pcVspPic && cIdx == num_ref_idx_l0_active_minus1 )
+#endif
     {
       m_apcRefPicList[0][cIdx] = RefPicSetVspCurr[0];
@@ -555,5 +582,12 @@
     }
     else
+    {
+#if VSP_CFG
+      m_apcRefPicList[0][cIdx] = m_RefPicListModification.getRefPicListModificationFlagL0() ? refPicListTemp0[ m_RefPicListModification.getRefPicSetIdxL0(cIdxTmp) ] : refPicListTemp0[cIdxTmp];
+      cIdxTmp++;
+#else
       m_apcRefPicList[0][cIdx] = m_RefPicListModification.getRefPicListModificationFlagL0() ? refPicListTemp0[ m_RefPicListModification.getRefPicSetIdxL0(cIdx) ] : refPicListTemp0[cIdx];
+#endif
+    }
 #else
     m_apcRefPicList[0][cIdx] = m_RefPicListModification.getRefPicListModificationFlagL0() ? refPicListTemp0[ m_RefPicListModification.getRefPicSetIdxL0(cIdx) ] : refPicListTemp0[cIdx];
@@ -567,8 +601,18 @@
   else
   {
+#if VSP_CFG
+    for( cIdx = 0, cIdxTmp = 0; cIdx <= num_ref_idx_l1_active_minus1; cIdx ++ )
+#else
     for( cIdx = 0; cIdx <= num_ref_idx_l1_active_minus1; cIdx ++ )
+#endif
     {
 #if VSP_N
+#if VSP_CFG
+      Int iVspRefPos = getVspRefPos(REF_PIC_LIST_1, 0);
+      iVspRefPos = ( iVspRefPos > 0 ? iVspRefPos - 1 : -1 );
+      if( pcVspPic && iVspRefPos != -1 && cIdx == (iVspRefPos >= num_ref_idx_l1_active_minus1 ? num_ref_idx_l1_active_minus1 : iVspRefPos) )
+#else
       if( pcVspPic && cIdx == num_ref_idx_l1_active_minus1 )
+#endif
       {
         m_apcRefPicList[1][cIdx] = RefPicSetVspCurr[0];
@@ -578,5 +622,12 @@
       }
       else
+      {
+#if VSP_CFG
+        m_apcRefPicList[1][cIdx] = m_RefPicListModification.getRefPicListModificationFlagL1() ? refPicListTemp1[ m_RefPicListModification.getRefPicSetIdxL1(cIdxTmp) ] : refPicListTemp1[cIdxTmp];
+        cIdxTmp++;
+#else
         m_apcRefPicList[1][cIdx] = m_RefPicListModification.getRefPicListModificationFlagL1() ? refPicListTemp1[ m_RefPicListModification.getRefPicSetIdxL1(cIdx) ] : refPicListTemp1[cIdx];
+#endif
+      }
 #else
       m_apcRefPicList[1][cIdx] = m_RefPicListModification.getRefPicListModificationFlagL1() ? refPicListTemp1[ m_RefPicListModification.getRefPicSetIdxL1(cIdx) ] : refPicListTemp1[cIdx];
@@ -1501,4 +1552,13 @@
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
 , m_bUseDMM                   (false)
+#endif
+#if OL_DEPTHLIMIT_A0044
+, m_bDepthPartitionLimiting   (false)
+#endif
+#if VSP_N
+, m_bVspPresentFlag           (false)
+#if VSP_CFG
+, m_bVspDepthPresentFlag      (false)
+#endif
 #endif
 {
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComSlice.h	(revision 193)
@@ -45,4 +45,5 @@
 #include "TComRom.h"
 #include "TComList.h"
+
 //! \ingroup TLibCommon
 //! \{
@@ -353,4 +354,8 @@
 #endif
 
+#if OL_DEPTHLIMIT_A0044
+  Bool m_bDepthPartitionLimiting;
+#endif
+
 #if DEPTH_MAP_GENERATION
   UInt  m_uiPredDepthMapGeneration;
@@ -372,4 +377,11 @@
 #if HHI_INTER_VIEW_RESIDUAL_PRED
   TComResidualGenerator* m_pcResidualGenerator;
+#endif
+
+#if VSP_N
+  Bool  m_bVspPresentFlag;
+#if VSP_CFG
+  Bool  m_bVspDepthPresentFlag;
+#endif
 #endif
 
@@ -618,4 +630,9 @@
 #endif
 
+#if OL_DEPTHLIMIT_A0044
+  Void setUseDPL(Bool b) {m_bDepthPartitionLimiting = b; }
+  Bool getUseDPL()       {return m_bDepthPartitionLimiting;}
+#endif
+
   Void initMultiviewSPS      ( UInt uiViewId, Int iViewOrderIdx = 0, UInt uiCamParPrecision = 0, Bool bCamParSlice = false, Int** aaiScale = 0, Int** aaiOffset = 0 );
   Void initMultiviewSPSDepth ( UInt uiViewId, Int iViewOrderIdx );
@@ -660,4 +677,13 @@
   Void                    setResidualGenerator( TComResidualGenerator* pcResidualGenerator )  { m_pcResidualGenerator = pcResidualGenerator; }
   TComResidualGenerator*  getResidualGenerator()                                              { return m_pcResidualGenerator; }
+#endif
+
+#if VSP_N
+  Void  setVspPresentFlag( Bool b ) { m_bVspPresentFlag = b; }
+  Bool  getVspPresentFlag()         { return m_bVspPresentFlag; }
+#if VSP_CFG
+  Void  setVspDepthPresentFlag( Bool b ) { m_bVspDepthPresentFlag = b; }
+  Bool  getVspDepthPresentFlag()         { return m_bVspDepthPresentFlag; }
+#endif
 #endif
 };
@@ -1277,4 +1303,10 @@
 #if VSP_SLICE_HEADER
   Bool      m_bVspFlag;
+#if VSP_CFG
+  UInt      m_uiNumVspRefPics;
+  UInt      m_uiVspRefPos[2][MAX_NUM_REF_PICS];
+#else
+  Bool      m_bVspDepthDisableFlag;
+#endif
 #endif
 
@@ -1584,4 +1616,13 @@
   Void      setVspFlag          ( Bool val )    { m_bVspFlag = val; }
   Bool      getVspFlag          ()              { return m_bVspFlag; }
+#if VSP_CFG
+  Void      setNumVspRefPics( UInt val )        { m_uiNumVspRefPics = val; }
+  UInt      getNumVspRefPics()                  { return m_uiNumVspRefPics; }
+  Void      setVspRefPos( UInt dir, UInt idx, UInt val )  { m_uiVspRefPos[dir][idx] = val; }
+  UInt      getVspRefPos( UInt dir, UInt idx )            { return m_uiVspRefPos[dir][idx]; }
+#else
+  Void      setVspDepthDisableFlag( Bool val )  { m_bVspDepthDisableFlag = val; }
+  Bool      getVspDepthDisableFlag()            { return m_bVspDepthDisableFlag; }
+#endif
 #endif
 
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComWedgelet.h
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComWedgelet.h	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComWedgelet.h	(revision 193)
@@ -198,5 +198,4 @@
   static UInt xGetSAD16         ( WedgeDistParam* pcDtParam );
   static UInt xGetSAD32         ( WedgeDistParam* pcDtParam );
-  //static UInt xGetSAD64         ( WedgeDistParam* pcDtParam );
 
   static UInt xGetSSE4          ( WedgeDistParam* pcDtParam );
@@ -204,5 +203,4 @@
   static UInt xGetSSE16         ( WedgeDistParam* pcDtParam );
   static UInt xGetSSE32         ( WedgeDistParam* pcDtParam );
-  //static UInt xGetSSE64         ( WedgeDistParam* pcDtParam );
 
 };// END CLASS DEFINITION TComWedgeDist
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComYuv.h
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComYuv.h	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TComYuv.h	(revision 193)
@@ -213,13 +213,4 @@
 
   __inline Pel  xClip  (Pel x )      { return ( (x < 0) ? 0 : (x > (Pel)g_uiIBDI_MAX) ? (Pel)g_uiIBDI_MAX : x ); }
-
-#if DEBUGIMGOUT
-public:
-  Void colsetToPicYuv   ( const UChar ucColor[3],                 Int iOffset[2][2], TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
-  Void colsetToPicLuma  ( const UChar ucLumaOffCol,               Int iOffset[2][2], TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
-  Void colsetToPicChroma( const UChar ucUCol, const UChar ucVCol, Int iOffset[2][2], TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
-  Void drawLineToPicYuv ( bool bHor, bool bVer, UInt uiSize,      TComPicYuv* pcPicYuvDst, UInt iCuAddr, UInt uiAbsZorderIdx, UInt uiPartDepth = 0, UInt uiPartIdx = 0 );
-#endif
-
 };// END CLASS DEFINITION TComYuv
 
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibCommon/TypeDef.h	(revision 193)
@@ -44,9 +44,8 @@
 #define VSP_N                             1
 #if VSP_N
-#define VSP_TEXT_ONLY                     1
-#define NUM_VIEW_VSP                      99
+#define VSP_BUGFIX                        1
 #define VSP_N_DUMP                        0
 #define FORCE_REF_VSP                     2   // 0=NotUseVSPSKIP 1:VSPSKIPforFlag 2:VSPSKIPforMergeIdx
-#define VSP_MV_ZERO                       0   // use zero vector for VSP
+#define VSP_MV_ZERO                       1   // use zero vector for VSP
 #if VSP_MV_ZERO
 #define AMVP_VSP_UNAVAILABLE              1
@@ -54,10 +53,11 @@
 #define VSP_MERGE_POS                     5   // position of vsp in merge list (0..5)
 #define NTT_SUBPEL                        1
-#endif
-#define DEBUGIMGOUT                       0   //Debug YUVImage Out
-#define DEBUGLOGOUT                       0   //Debug Log Out
+#define VSP_CFG                           1
+#endif
 
 #define VSP_SLICE_HEADER                  1
+#if !VSP_CFG
 #define VSP_FRAME_INTERVAL                2
+#endif
 
 #define FIXES                             1
@@ -66,7 +66,11 @@
 #define FIX_INIT_ROM                      1
 #define FIX_VIRT_DESTRUCTOR               1
-#define FIX_DBL_CONTROL_DEFAULT           1
+#define FIX_MEM_LEAKS                     1
+#define FIX_VSO_SETUP                     1
+#define FIX_COMP_WARNING_INIT             1
 #define FIX_RDO_MACRO                     1
 #define FIX_LG_RESTRICTEDRESPRED_M24766   1
+#define FIX_REMOVE_TILE_DEPENDENCE        1
+#define FIX_DBL_CONTROL_DEFAULT           1
 
 
@@ -116,5 +120,12 @@
 #define SAIT_VSO_EST_A0033                1 // JCT2-A0033 modification 3
 #define LGE_VSO_EARLY_SKIP_A0093          1 // JCT2-A0093 modification 4
-
+#define LGE_WVSO_A0119                    1 // JCT2-A0119 Depth Metric with a weighted depth fidelity term
+
+#define OL_DEPTHLIMIT_A0044               1 //JCT2-A0044
+#if OL_DEPTHLIMIT_A0044
+#define OL_DO_NOT_LIMIT_INTRA_SLICES_PART 1 //Turn this on to not perform depth limiting for I-SLICES.
+#define OL_END_CU                         MAX_INT //Default for initializing the partition information buffer
+#define OL_PART_BUF_SIZE                  86 //maximum number of possible partition bits in a CU
+#endif
 
 #define HHI_INTERVIEW_SKIP                1
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCAVLC.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 193)
@@ -1757,4 +1757,18 @@
       }
     }
+#if VSP_N
+    if( pcSPS->getViewId() )
+    {
+      READ_FLAG( uiCode, "vsp_present_flag" );
+      pcSPS->setVspPresentFlag( (Bool)uiCode );
+#if VSP_CFG
+      if( pcSPS->getVspPresentFlag() )
+      {
+        READ_FLAG( uiCode, "vsp_depth_present_flag" );
+        pcSPS->setVspDepthPresentFlag( (Bool)uiCode );
+      }
+#endif
+    }
+#endif
     READ_FLAG( uiCode, "sps_extension2_flag");
     if (uiCode)
@@ -1781,5 +1795,8 @@
   UInt  uiCode;
   Int   iCode;
-  
+#if VSP_CFG
+  Int   iNumOfVspRefsL0 = 0;
+  Int   iNumOfVspRefsL1 = 0;
+#endif
 #if ENC_DEC_TRACE
   xTraceSliceHeader(rpcSlice);
@@ -2006,4 +2023,41 @@
       READ_UVLC (    uiCode, "aps_id" );  rpcSlice->setAPSId(uiCode);
     }
+
+#if VSP_SLICE_HEADER && VSP_CFG
+    if( rpcSlice->getSPS()->getViewId()!=0 
+     && rpcSlice->getSliceType() != I_SLICE
+     && rpcSlice->getSPS()->getVspPresentFlag()
+      )
+    {
+      if( !rpcSlice->getSPS()->isDepth() || rpcSlice->getSPS()->getVspDepthPresentFlag() )
+      {
+        READ_UVLC( uiCode, "num_vsp_ref_pics");
+        rpcSlice->setVspFlag( uiCode > 0 ? true : false );
+        rpcSlice->setNumVspRefPics( uiCode );
+        //printf("SH:num_vsp_ref_pics(%d)\n",uiCode);
+        for( UInt i = 0; i < rpcSlice->getNumVspRefPics(); i++ )
+        {
+          READ_UVLC( uiCode, "vsp_ref_list0_pos");
+          rpcSlice->setVspRefPos( REF_PIC_LIST_0, i, uiCode );
+          //printf("SH:vsp_ref_list0_pos(%d)\n",uiCode);
+          if( rpcSlice->getSliceType() == B_SLICE )
+          {
+            READ_UVLC( uiCode, "vsp_ref_list1_pos");
+            rpcSlice->setVspRefPos( REF_PIC_LIST_1, i, uiCode );
+            //printf("SH:vsp_ref_list1_pos(%d)\n",uiCode);
+          }
+        }
+        iNumOfVspRefsL0 = ( (rpcSlice->getSPS()->getViewId()==0 
+                         || (!rpcSlice->getSPS()->getVspDepthPresentFlag() && rpcSlice->getSPS()->isDepth()) 
+                         || !rpcSlice->getVspFlag() 
+                         || rpcSlice->getVspRefPos(REF_PIC_LIST_0, 0) == 0 ) ? 0 : 1 );
+        iNumOfVspRefsL1 = ( (rpcSlice->getSPS()->getViewId()==0 
+                         || (!rpcSlice->getSPS()->getVspDepthPresentFlag() && rpcSlice->getSPS()->isDepth()) 
+                         || !rpcSlice->getVspFlag() 
+                         || rpcSlice->getVspRefPos(REF_PIC_LIST_1, 0) == 0 ) ? 0 : 1 );
+      }
+    }
+#endif
+
     if (!rpcSlice->isIntra())
     {
@@ -2011,8 +2065,18 @@
       if (uiCode)
       {
-        READ_CODE (3, uiCode, "num_ref_idx_l0_active_minus1" );  rpcSlice->setNumRefIdx( REF_PIC_LIST_0, uiCode + 1 );
+        READ_CODE (3, uiCode, "num_ref_idx_l0_active_minus1" );  
+#if VSP_CFG
+        rpcSlice->setNumRefIdx( REF_PIC_LIST_0, uiCode + 1 + iNumOfVspRefsL0 );
+#else
+        rpcSlice->setNumRefIdx( REF_PIC_LIST_0, uiCode + 1 );
+#endif
         if (rpcSlice->isInterB())
         {
-          READ_CODE (3, uiCode, "num_ref_idx_l1_active_minus1" );  rpcSlice->setNumRefIdx( REF_PIC_LIST_1, uiCode + 1 );
+          READ_CODE (3, uiCode, "num_ref_idx_l1_active_minus1" );  
+#if VSP_CFG
+          rpcSlice->setNumRefIdx( REF_PIC_LIST_1, uiCode + 1 + iNumOfVspRefsL1 );
+#else
+          rpcSlice->setNumRefIdx( REF_PIC_LIST_1, uiCode + 1 );
+#endif
         }
         else
@@ -2183,5 +2247,10 @@
     if(uiCode)
     {
-      READ_UVLC( uiCode, "num_ref_idx_lc_active_minus1" );      rpcSlice->setNumRefIdx( REF_PIC_LIST_C, uiCode + 1 );
+      READ_UVLC( uiCode, "num_ref_idx_lc_active_minus1" );      
+#if VSP_CFG
+      rpcSlice->setNumRefIdx( REF_PIC_LIST_C, uiCode + 1 + iNumOfVspRefsL0 );
+#else
+      rpcSlice->setNumRefIdx( REF_PIC_LIST_C, uiCode + 1 );
+#endif
       
 #if H0412_REF_PIC_LIST_RESTRICTION
@@ -2348,14 +2417,19 @@
 #endif
 
+#if !VSP_CFG
 #if VSP_SLICE_HEADER
   if( rpcSlice->getSPS()->getViewId()!=0 
-#if VSP_TEXT_ONLY
-      && !(rpcSlice->getSPS()->isDepth()) 
-#endif
+   && rpcSlice->getSPS()->getVspPresentFlag()
     )
   {
     READ_FLAG( uiCode, "vsp_flag" );
     rpcSlice->setVspFlag( uiCode ? true : false );
-  }
+    if( rpcSlice->getVspFlag() )
+    {
+      READ_FLAG( uiCode, "vsp_depth_disable_flag" );
+      rpcSlice->setVspDepthDisableFlag( uiCode ? true : false );
+    }
+  }
+#endif
 #endif
 
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCu.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCu.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCu.cpp	(revision 193)
@@ -351,6 +351,8 @@
 #if FORCE_REF_VSP==1
     if( pcCU->isSkipped(uiAbsPartIdx) && pcCU->getSlice()->getViewId() != 0 )
-#if VSP_TEXT_ONLY
-    if( !pcCU->getSlice()->getSPS()->isDepth() )
+#if VSP_CFG
+    if( pcCU->getSlice()->getSPS()->getVspDepthPresentFlag() || !pcCU->getSlice()->getSPS()->isDepth() )
+#else
+    if( !pcCU->getSlice()->getVspDepthDisableFlag() || !pcCU->getSlice()->getSPS()->isDepth() )
 #endif
     {
@@ -385,14 +387,6 @@
     if( pcCU->getTextureModeDepth( uiAbsPartIdx ) == uiDepth )
     {
-#if DEBUGLOGOUT
-      PredMode   eOrgPred = pcCU->getPredictionMode( uiAbsPartIdx );
-#endif
       TComDataCU *pcTextureCU = pcCU->getSlice()->getTexturePic()->getCU( pcCU->getAddr() );
       pcCU->copyTextureMotionDataFrom( pcTextureCU, uiDepth, pcCU->getZorderIdxInCU() + uiAbsPartIdx, uiAbsPartIdx );
-#if DEBUGLOGOUT
-      if( eOrgPred == MODE_SKIP )
-        pcCU->setPredModeSubParts( MODE_SKIP, uiAbsPartIdx, uiDepth );
-      m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
-#endif
 
       UInt uiCurrPartNumb = pcCU->getPic()->getNumPartInCU() >> (uiDepth << 1);
@@ -437,10 +431,4 @@
 #endif
     xFinishDecodeCU( pcCU, uiAbsPartIdx, uiDepth, ruiIsLast );
-#if DEBUGLOGOUT
-#if HHI_MPI
-    if( pcCU->getTextureModeDepth( uiAbsPartIdx ) != uiDepth )
-#endif
-      m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
-#endif
     return;
   }
@@ -472,7 +460,4 @@
 
     xFinishDecodeCU( pcCU, uiAbsPartIdx, uiDepth, ruiIsLast );
-#if DEBUGLOGOUT
-    m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
-#endif
     return;
   }
@@ -508,7 +493,4 @@
     {
       xFinishDecodeCU( pcCU, uiAbsPartIdx, uiDepth, ruiIsLast );
-#if DEBUGLOGOUT
-      m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
-#endif
       return;
     }
@@ -610,7 +592,4 @@
   setdQPFlag( bCodeDQP );
   xFinishDecodeCU( pcCU, uiAbsPartIdx, uiDepth, ruiIsLast );
-#if DEBUGLOGOUT
-  m_cDebug.DebugLogOut( pcCU, uiAbsPartIdx, uiDepth );
-#endif
 }
 
@@ -710,7 +689,4 @@
   
   xCopyToPic( m_ppcCU[uiDepth], pcPic, uiAbsPartIdx, uiDepth );
-#if DEBUGIMGOUT
-  xColsetToPicMerge( m_ppcCU[uiDepth], pcPic->getPicYuvRecDbg(), uiAbsPartIdx, uiDepth );
-#endif
 }
 
@@ -724,4 +700,5 @@
   // inter prediction
   m_pcPrediction->motionCompensation( pcCU, m_ppcYuvReco[uiDepth] );
+
 #if HHI_MPI
   if( pcCU->getTextureModeDepth( 0 ) != -1 )
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCu.h
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCu.h	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecCu.h	(revision 193)
@@ -46,7 +46,4 @@
 #include "TLibCommon/TComPrediction.h"
 #include "TDecEntropy.h"
-#if DEBUGIMGOUT || DEBUGLOGOUT
-#include "TLibCommon/DebugLog.h"
-#endif
 
 //! \ingroup TLibDecoder
@@ -84,8 +81,4 @@
   virtual ~TDecCu();
   
-#if DEBUGLOGOUT
-  DebugLog            m_cDebug;
-#endif
-
   /// initialize access channels
   Void  init                    ( TDecEntropy* pcEntropyDecoder, TComTrQuant* pcTrQuant, TComPrediction* pcPrediction );
@@ -132,8 +125,4 @@
   Void xFillPCMBuffer           (TComDataCU* pCU, UInt absPartIdx, UInt depth);
 #endif
-#if DEBUGIMGOUT
-  Void xColsetToPic             ( TComDataCU* pcCU, TComPicYuv* pcPicYuv, UInt uiZorderIdx, UInt uiDepth );
-  Void xColsetToPicMerge        ( TComDataCU* pcCU, TComPicYuv* pcPicYuv, UInt uiZorderIdx, UInt uiDepth );
-#endif
 };
 
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecEntropy.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 193)
@@ -310,5 +310,5 @@
 #if VSP_MV_ZERO
           Int iRefIdx = pcCU->getCUMvField( RefPicList( uiRefListIdx ) )->getRefIdx(uiSubPartIdx);
-          if( pcCU->getSlice()->getViewId() && iRefIdx >= 0 && (pcCU->getSlice()->getRefViewId( RefPicList( uiRefListIdx ), iRefIdx ) == NUM_VIEW_VSP) )
+          if( pcCU->getSlice()->getViewId() && iRefIdx >= 0 && pcCU->isVspRef( RefPicList( uiRefListIdx ), iRefIdx ) )
           {
             pcCU->getCUMvField( RefPicList( uiRefListIdx ) )->setAllMvd( TComMv(0, 0), pcCU->getPartitionSize( uiSubPartIdx ), uiSubPartIdx, uiDepth, uiPartIdx );
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecGop.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecGop.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecGop.cpp	(revision 193)
@@ -463,4 +463,11 @@
           printf( "V%d ", pcSlice->getRefViewId( RefPicList(iRefList), iRefIndex ) );
         }
+#if VSP_CFG
+        else if( pcSlice->getViewId() == pcSlice->getRefViewId( RefPicList(iRefList), iRefIndex )
+              && pcSlice->getPOC()    == pcSlice->getRefPOC( RefPicList(iRefList), iRefIndex ) )
+        {
+          printf( "VS " );
+        }
+#endif
         else
         {
@@ -479,4 +486,11 @@
           printf( "V%d ", pcSlice->getRefViewId( (RefPicList)pcSlice->getListIdFromIdxOfLC(iRefIndex), pcSlice->getRefIdxFromIdxOfLC(iRefIndex) ) );
         }
+#if VSP_CFG
+        else if( pcSlice->getViewId() == pcSlice->getRefViewId( (RefPicList)pcSlice->getListIdFromIdxOfLC(iRefIndex), pcSlice->getRefIdxFromIdxOfLC(iRefIndex) )
+              && pcSlice->getPOC()    == pcSlice->getRefPOC( (RefPicList)pcSlice->getListIdFromIdxOfLC(iRefIndex), pcSlice->getRefIdxFromIdxOfLC(iRefIndex) ) )
+        {
+          printf( "VS " );
+        }
+#endif
         else
         {
